﻿using max.Models;
using max.PrimaryAccess;
using max.Views;
using MaxAPI.RestAPIClient;
using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.ComponentModel;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using Xamarin.Forms;
using static Gomax.Models.WoDetailsServices;
using System.Globalization;
using System.Runtime.CompilerServices;

namespace max.ViewModels
{
    class ListVM : System.ComponentModel.INotifyPropertyChanged
    {
        private int totalItems = 100;
        public string Mode = "LIST";
        public string SelectedStatus;
        int initialCount=0;
        private bool isBusy;
        public bool IsBusy
        {
            get { return isBusy; }
            set
            {
                this.isBusy = value;
                RaisePropertyChanged("IsBusy");
            }
        }

        public event PropertyChangedEventHandler PropertyChanged;
        private void RaisePropertyChanged(string name)
        {
            if (PropertyChanged != null)
                PropertyChanged(this, new PropertyChangedEventArgs(name));
        }

        public System.Collections.ObjectModel.ObservableCollection<WOList> list { get; set; }
        public Command<object> LoadMoreItemsCommand { get; set; }

        public void SetMode(string mode)
        {
            var Mode = mode;
        }

        public ListVM()
        {
            list = new ObservableCollection<list>();
            LoadMoreItemsCommand = new Command<object>(LoadMoreItems, CanLoadMoreItems);
            //SetMode(mode);
        }

        private bool CanLoadMoreItems(object obj)
        {
            if (list.Count >= totalItems)
                return false;
            else if (initialCount > 0 && list.Count == 0)
                return false;        
            return true;
        }

        private async void LoadMoreItems(object obj)
        {
            var listview = obj as Syncfusion.ListView.XForms.SfListView;
            if (IsBusy)
                return;
            IsBusy = true;
            int index = list.Count;
            await FetchData(index, 25);
            IsBusy = false;
        }

        public async Task FetchData(int index, int count)
        {
            
            if (Common.WO_STATUS_FILTER.Length > 0)
            {
                SelectedStatus = Common.WO_STATUS_FILTER;
            }
            
            var woDetails = new Access();
            initialCount = initialCount + 1;
            List<list> lst = await woDetails.GetData(index, count, Mode, SelectedStatus);

            if (lst.Count == 0)
            {
                isListNull = true;
            }
            else
            {
                isListNull = false;
            foreach (list w in lst)
            {
                woList.Add(w);
            }
        }
        }

        public bool IsListNull { get; set; }
        public bool isListNull
        {
            get
            {
                return IsListNull;
            }
            set
            {
                IsListNull = value;
                OnPropertyChanged();
            }
        }
        protected virtual void OnPropertyChanged([CallerMemberName] string propertyName = null)
        {
            PropertyChanged?.Invoke(this, new PropertyChangedEventArgs(propertyName));
        }     

        //For Sending properties to another page (Start)

        private Command<object> tapCommand;
        private INavigation navigation;

        public Command<object> TapCommand
        {
            get { return tapCommand; }
            set { tapCommand = value; }
        }

        public INavigation Navigation
        {
            get { return navigation; }
            set { navigation = value; }
        }

        public ListVM(INavigation _navigation)
        {
            navigation = _navigation;
            tapCommand = new Command<object>(OnTapped);
        }

        ///<summary>        
        /// Navigating to a desired page on item tapped.
        ///</summary>
        private void OnTapped(object obj)
        {
            var newPage = new EditWoPage(obj);
            newPage.BindingContext = obj;
            Navigation.PushAsync(newPage);
        }
        //End
    }
}
